//
//
{
  gROOT->Reset();
  gSystem->Load("liblangau.so");

  TCanvas *c;
  TPhEvent *ev;
  TPhRecTrack *track;
  TPhTrackSeedFinder *tseed;
  TPhDetector *det;
  TPhHit *Hit;
// convsion to energy
//  Double_t kQtoE=2.2596;

//  const Float_t kMove = -0.0;

  Double_t NSenTh[8] = {300./304.,300./302.,300./304.,300./308.,
		300./331.,300./326.,300./325.,300./326.};

  if(!TPhDetector::GetInstance()) {
    TFile f("$PHATHOME/init/Detector_TB98.root");
//    TFile f("Detector_TB98.root");
    det = (TPhDetector*)f.Get("TB98_V1.0;1");
    det->SetVerbose(10);
    det->Print();

  } else
    det = TPhDetector::GetInstance();
  
  tseed = new TPhTrackSeedFinder();
  tseed->Reset();
  tseed->SetVerbose(0);
  tseed->SetMulguisinMode(4);
  tseed->SetMulguisinResol(0.2);
  tseed->SetMulguisinLayer(3);
  tseed->SetMergeHit(0);

  TPhDST data("run012.dat_0_10000.root");
  TH1F *h_hits0 = new TH1F("Hits0", "Hits0", 105, -50, 300);
  TH1F *h_hits1 = new TH1F("Hits1", "Hits1", 105, -50, 300);
  TH1F *h_hits2 = new TH1F("Hits2", "Hits2", 105, -50, 300);
  TH1F *h_hits3 = new TH1F("Hits3", "Hits3", 105, -50, 300);
  TH1F *h_hits4 = new TH1F("Hits4", "Hits4", 105, -50, 300);
  TH1F *h_hits5 = new TH1F("Hits5", "Hits5", 105, -50, 300);
  TH1F *h_hits6 = new TH1F("Hits6", "Hits6", 105, -50, 300);
  TH1F *h_hits7 = new TH1F("Hits7", "Hits7", 105, -50, 300);
  TH1F *h_all_03 = new TH1F("HitsH", "HitsH", 105, -50, 300);
  TH1F *h_all_47 = new TH1F("HitsSJ", "HitsSJ", 105, -50, 300);


//TH1F *h_ent_track = new TH1F("Track", "Entries per track", 10, -0.5, 9.5);
//TH2F *h_xy = new TH2F("X-Y", "X-Y hit distribution",200,-10.,10.,100,-5.,5.);

//  c1 = new TCanvas("Hittracks1");
//  c1->Divide(2, 1);
//  c2 = new TCanvas("Hittracks2");
//  c2->Divide(2, 1);
//  c3 = new TCanvas("Hittracks3");
//  c3->Divide(2, 1);
//  c4 = new TCanvas("Hittracks4");
//  c4->Divide(2, 1);
 //  c->SetFillColor(1);

  Int_t counter = 0;
  while(ev = data.GetNextEvent() && counter++ < 20000) {
    det->SetEvent(ev);
    if ( !(counter%100) ) ev->Print();

    TPhObjectContainer *h = 
      (TPhObjectContainer*)ev->GetObject("HitsSuppressed");

    TIter NextHit(h->GetIterator());

    det->FillWithEventHits("HitsSuppressed");
    tseed->RunMulguisin();
//    h_ent_track->Fill(tseed->GetTrackSeedList()->GetEntries());

    track = (TPhRecTrack*)tseed->GetTrackSeedList()->At(0);

    Int_t k;
    if(track && tseed->GetTrackSeedList()->GetEntries() == 1) {
    /*    for(k=0; k<tseed->GetTrackSeedList()->GetEntries();k++) {
      track =  (TPhRecTrack*)tseed->GetTrackSeedList()->At(k);
      */
      Int_t i;
      Int_t j;
      for(i = 0; i < track->GetHitList()->GetEntries(); i++) {
	Hit = (TPhHit*) track->GetHitList()->At(i);
	//		printf("sensorlabel= %d\n", Hit->GetSensorLabel());
	//      	printf("hit De = %f\n", Hit->GetDe());
	j = Hit->GetSensorLabel();
       	if(j==0) h_hits0->Fill((Hit->GetDe())*1000000*NSenTh[0]);
	if(j==1) h_hits1->Fill((Hit->GetDe())*1000000*NSenTh[1]);
	if(j==2) h_hits2->Fill((Hit->GetDe())*1000000*NSenTh[2]);
	if(j==3) h_hits3->Fill((Hit->GetDe())*1000000*NSenTh[3]);
	if(j==4) h_hits4->Fill((Hit->GetDe())*1000000*NSenTh[4]);
	if(j==5) h_hits5->Fill((Hit->GetDe())*1000000*NSenTh[5]);
	if(j==6) h_hits6->Fill((Hit->GetDe())*1000000*NSenTh[6]);
	if(j==7) h_hits7->Fill((Hit->GetDe())*1000000*NSenTh[7]);
        if((j-4)<0) {
	  h_all_03->Fill( (Hit->GetDe())*1000000*(NSenTh[j]*1.) );
	} else {
	  h_all_47->Fill( (Hit->GetDe())*1000000*(NSenTh[j]*1.) );
	}
//        h_xy->Fill(Hit->GetX(),Hit->GetY(),1.);
      }
    }
    delete ev;
  }


/*
  h_all_n->Add(h_hits0,h_hits1,NSenTh[0],NSenTh[1]);
  h_all_n->Add(h_hits2,h_all_n,NSenTh[2],1.);
  h_all_n->Add(h_hits3,h_all_n,NSenTh[3],1.);
  h_all_n->Add(h_hits4,h_all_n,NSenTh[4],1.);
  h_all_n->Add(h_hits5,h_all_n,NSenTh[5],1.);
  h_all_n->Add(h_hits6,h_all_n,NSenTh[6],1.);
  h_all_n->Add(h_hits7,h_all_n,NSenTh[7],1.);
*/

//  b = new TCanvas("XY");
//  h_xy->Draw();

/*
TF1 *langaufit(TH1F *his, Double_t *fitrange, Double_t *startvalues, Double_t *parlimitslo, Double_t *parlimitshi, Double_t &fitparams[4])
   his             histogram to fit
   fitrange[2]     lo and hi boundaries of fit range
   startvalues[4]  reasonable start values for the fit
   parlimitslo[4]  lower parameter limits
   parlimitshi[4]  upper parameter limits
   fitparams[4]    returns the final fit parameters
*/
//  TF1 *fitf_0;
//  TF1 *fitf_1;
//  TF1 *fitf_2;
//  TF1 *fitf_3;
//  TF1 *fitf_4;
//  TF1 *fitf_5;
//  TF1 *fitf_6;
//  TF1 *fitf_7;

//  fitf_0 = langaufit(h_hits0, fr, sv, pllo, plhi, fp);
//  for(i=0; i<4; i++)     printf(" par[%1d]=%10.4f\n",i,fp[i]);

//  fitf_1 = langaufit(h_hits1, fr, sv, pllo, plhi, fp);
//  for(i=0; i<4; i++)     printf(" par[%1d]=%10.4f\n",i,fp[i]);

//  fitf_2 = langaufit(h_hits2, fr, sv, pllo, plhi, fp);
//  for(i=0; i<4; i++)     printf(" par[%1d]=%10.4f\n",i,fp[i]);

//  fitf_3 = langaufit(h_hits3, fr, sv, pllo, plhi, fp);
//  for(i=0; i<4; i++)     printf(" par[%1d]=%10.4f\n",i,fp[i]);

//  fitf_4 = langaufit(h_hits4, fr, sv, pllo, plhi, fp);
//  for(i=0; i<4; i++)     printf(" par[%1d]=%10.4f\n",i,fp[i]);

//  fitf_5 = langaufit(h_hits5, fr, sv, pllo, plhi, fp);
//  for(i=0; i<4; i++)     printf(" par[%1d]=%10.4f\n",i,fp[i]);

//  fitf_6 = langaufit(h_hits6, fr, sv, pllo, plhi, fp);
//  for(i=0; i<4; i++)     printf(" par[%1d]=%10.4f\n",i,fp[i]);


//  fitf_7 = langaufit(h_hits7, fr, sv, pllo, plhi, fp);
//  for(i=0; i<4; i++)     printf(" par[%1d]=%10.4f\n",i,fp[i]);

  Double_t fr[2] = {60.0,200.0};
  Double_t sv[4] = {5.0,80.0,2000.0,10.0};
  Double_t pllo[4] = {1,10,0,0};
  Double_t plhi[4] = {100,300,10000000,200};
  Double_t fp[4];

  TF1 *fitf_all;
  Double_t max, fwhm;
  fitf_all = langaufit(h_all_03, fr, sv, pllo, plhi, fp);
  langaupro(fp,max,fwhm);
  d = new TCanvas("HitsHbatch");
  d.cd();
  h_all_03->Draw();

  printf("H batch peak at %f FWHM at %f\n",max,fwhm);
  fitf_all = langaufit(h_all_47, fr, sv, pllo, plhi, fp);
  langaupro(fp,max,fwhm);
  e = new TCanvas("HitssJbatch");
  e.cd();
  h_all_47->Draw("same");
  printf("SJ batch peak at %f FWHM at %f\n",max,fwhm);
  TFile *hf=new TFile("hist.root","recreate");
  hf.cd();
  h_all_03->Write();
  h_all_47->Write();
  hf.Close();

//  for(i=0; i<4; i++)     printf(" par[%1d]=%10.4f\n",i,fp[i]);


}

















